package com.lanren.huhu.partner.constants;

import java.math.BigDecimal;
import java.util.HashMap;
import java.util.Map;

/**
 * @author chen
 * @title: Constants
 * @projectName partner
 * @description: 常量
 * @package com.lanren.huhu.partner.constants
 * @date 2019-06-29 17:04
 */
public class Constants {
    public static final String AGENT_REWARD_QUEUE_KEY = "agent_reward_redis_city_key";
    /**
     * 奖励类型
     */
    public static final int AGENT_REWARD_TYPE_YEAR_VIP = 710;
    public static final String AGENT_REWARD_TYPE_YEAR_VIP_REMARK = "城市代理商所得的购买年-VIP";
    public static final int AGENT_REWARD_TYPE_HALF_YEAR_VIP = 720;
    public static final String AGENT_REWARD_TYPE_HALF_YEAR_VIP_REMARK = "城市代理商所得的购买半年-VIP";
    public static final int AGENT_REWARD_TYPE_SVIP = 730;
    public static final String AGENT_REWARD_TYPE_SVIP_REMARK = "城市代理商所得的购买超级VIP收益";
    public static final int AGENT_REWARD_TYPE_REDPACK = 740;
    public static final String AGENT_REWARD_TYPE_REDPACK_REMARK = "城市代理商的红包收益";
    public static final int AGENT_REWARD_TYPE_SELF_ORDER = 750;
    public static final String AGENT_REWARD_TYPE_SELF_ORDER_REMARK = "城市代理商的自购省收益";
    public static final int AGENT_REWARD_TYPE_SHARE_ORDER = 760;
    public static final String AGENT_REWARD_TYPE_SHARE_ORDER_REMARK = "城市代理商的分享赚收益";
    public static Map<Integer, Map<Integer, BigDecimal>> AGENT_RATE_MAP = new HashMap<Integer, Map<Integer, BigDecimal>>();
    public static Map<Integer, String> AGENT_REWARD_REMARK = new HashMap<Integer, String>();
    public static final int AGENT_LEVEL_1 = 1;
    public static final int AGENT_LEVEL_2 = 2;
    public static final int AGENT_LEVEL_3 = 3;
    public static final int AGENT_LEVEL_4 = 4;
    public static final String DATE_FORMAT = "yyyy-MM-dd hh:mm:ss";
    public static final String DISTRIBUTE_REDIS_LOCK_KEY = "huhu:partner:distribute:redis:key";
    public static final String PARENT_COLUMN_NAME_CENGJI = "parent_agent_id";
    public static final String PARENT_COLUMN_NAME_PINGTUI = "presenter_id";
    /**
     * 回扣类型
     */
    public static final int AGENT_REVOKE_TYPE_ACTIVATION = 100;
    public static final String AGENT_REVOKE_TYPE_ACTIVATION_REMARK = "下单激活奖励扣回";
    public static final int AGENT_REVOKE_TYPE_SELF_ORDER = 300;
    public static final String AGENT_REVOKE_TYPE_SELF_ORDER_REMARK = "自购省奖励扣回";
    public static final int AGENT_REVOKE_TYPE_SHARE_ORDER = 400;
    public static final String AGENT_REVOKE_TYPE_SHARE_ORDER_REMARK = "分享赚奖励扣回";
    public static Map<Integer, String> AGENT_REVOKE_TYPE_MAP = new HashMap<Integer, String>();
    /**
     * 回扣状态
     */
    public static final int REVOKE_STATE_PENDING = 100;
    public static final int REVOKE_STATE_DONE = 120;
    public static final int REVOKE_STATE_DO_NOTHING = 190;
    public static final int REVOKE_STATE_FAILED = 99;
    /**
     * 结算状态
     */
    public static final int SETTLE_STATE_ON_THE_WAY = 100;
    public static final int SETTLE_STATE_PRE = 200;
    public static final int SETTLE_STATE_DONE = 300;

    /**
     * 最小奖励金额 小于此不写入
     */
    public static final BigDecimal MIN_REWARD = new BigDecimal("0.000001");

    /**
     * 代理商奖励push队列
     */
    public static final String AGENT_REWARD_PUSH_KEY = "agent:reward:queue";

    static {
        /**
         * 代理商平推奖励比例配置
         */
        AGENT_RATE_MAP.put(AGENT_REWARD_TYPE_YEAR_VIP, new HashMap<Integer, BigDecimal>());
        AGENT_RATE_MAP.put(AGENT_REWARD_TYPE_HALF_YEAR_VIP, new HashMap<Integer, BigDecimal>());
        AGENT_RATE_MAP.put(AGENT_REWARD_TYPE_SVIP, new HashMap<Integer, BigDecimal>());
        AGENT_RATE_MAP.put(AGENT_REWARD_TYPE_REDPACK, new HashMap<Integer, BigDecimal>());
        AGENT_RATE_MAP.put(AGENT_REWARD_TYPE_SELF_ORDER, new HashMap<Integer, BigDecimal>());
        AGENT_RATE_MAP.put(AGENT_REWARD_TYPE_SHARE_ORDER, new HashMap<Integer, BigDecimal>());

        AGENT_RATE_MAP.get(AGENT_REWARD_TYPE_YEAR_VIP).put(0, new BigDecimal("0.03333333"));
        AGENT_RATE_MAP.get(AGENT_REWARD_TYPE_YEAR_VIP).put(1, new BigDecimal("0.01388889"));
        AGENT_RATE_MAP.get(AGENT_REWARD_TYPE_YEAR_VIP).put(2, new BigDecimal("0.00833333"));

        AGENT_RATE_MAP.get(AGENT_REWARD_TYPE_HALF_YEAR_VIP).put(0, new BigDecimal("0.03015075"));
        AGENT_RATE_MAP.get(AGENT_REWARD_TYPE_HALF_YEAR_VIP).put(1, new BigDecimal("0.01256281"));
        AGENT_RATE_MAP.get(AGENT_REWARD_TYPE_HALF_YEAR_VIP).put(2, new BigDecimal("0.00753769"));

        AGENT_RATE_MAP.get(AGENT_REWARD_TYPE_SVIP).put(0, new BigDecimal("0.02500000"));
        AGENT_RATE_MAP.get(AGENT_REWARD_TYPE_SVIP).put(1, new BigDecimal("0.01111111"));
        AGENT_RATE_MAP.get(AGENT_REWARD_TYPE_SVIP).put(2, new BigDecimal("0.00555556"));

        AGENT_RATE_MAP.get(AGENT_REWARD_TYPE_REDPACK).put(0, new BigDecimal("0.03"));
        AGENT_RATE_MAP.get(AGENT_REWARD_TYPE_REDPACK).put(1, new BigDecimal("0.02"));
        AGENT_RATE_MAP.get(AGENT_REWARD_TYPE_REDPACK).put(2, new BigDecimal("0.01"));
        AGENT_RATE_MAP.get(AGENT_REWARD_TYPE_SELF_ORDER).put(0, new BigDecimal("0.03"));
        AGENT_RATE_MAP.get(AGENT_REWARD_TYPE_SELF_ORDER).put(1, new BigDecimal("0.02"));
        AGENT_RATE_MAP.get(AGENT_REWARD_TYPE_SELF_ORDER).put(2, new BigDecimal("0.01"));
        AGENT_RATE_MAP.get(AGENT_REWARD_TYPE_SHARE_ORDER).put(0, new BigDecimal("0.03"));
        AGENT_RATE_MAP.get(AGENT_REWARD_TYPE_SHARE_ORDER).put(1, new BigDecimal("0.02"));
        AGENT_RATE_MAP.get(AGENT_REWARD_TYPE_SHARE_ORDER).put(2, new BigDecimal("0.01"));

        AGENT_REWARD_REMARK.put(AGENT_REWARD_TYPE_YEAR_VIP, AGENT_REWARD_TYPE_YEAR_VIP_REMARK);
        AGENT_REWARD_REMARK.put(AGENT_REWARD_TYPE_HALF_YEAR_VIP, AGENT_REWARD_TYPE_HALF_YEAR_VIP_REMARK);
        AGENT_REWARD_REMARK.put(AGENT_REWARD_TYPE_SVIP, AGENT_REWARD_TYPE_SVIP_REMARK);
        AGENT_REWARD_REMARK.put(AGENT_REWARD_TYPE_REDPACK, AGENT_REWARD_TYPE_REDPACK_REMARK);
        AGENT_REWARD_REMARK.put(AGENT_REWARD_TYPE_SELF_ORDER, AGENT_REWARD_TYPE_SELF_ORDER_REMARK);
        AGENT_REWARD_REMARK.put(AGENT_REWARD_TYPE_SHARE_ORDER, AGENT_REWARD_TYPE_SHARE_ORDER_REMARK);
        /**
         * 代理商奖励回扣类型
         */
        AGENT_REVOKE_TYPE_MAP.put(AGENT_REVOKE_TYPE_ACTIVATION, AGENT_REVOKE_TYPE_ACTIVATION_REMARK);
        AGENT_REVOKE_TYPE_MAP.put(AGENT_REVOKE_TYPE_SELF_ORDER, AGENT_REVOKE_TYPE_SELF_ORDER_REMARK);
        AGENT_REVOKE_TYPE_MAP.put(AGENT_REVOKE_TYPE_SHARE_ORDER, AGENT_REVOKE_TYPE_SHARE_ORDER_REMARK);
    }
}
